\newcommand\classname{Avenir_MIT}
\newcommand\lastmodifieddate{2020/08/03}
\newcommand\versionnumber{0.1}

% Are we printing crop marks?
\newif\if@cropmarkson \@cropmarksontrue
\newif\ifsixbynine \sixbyninetrue%6x9 inches, fixed by default
\newif\ifsevenbyten%7x9
\newif\ifsevenbytenwide%7x9
\newif\ifeightbyten%8x9
\newif\ifappendon%
\newif\ifthmcountchapter%
\newif\ifthmcountcont%

\newif\if@aheadpresent\global\@aheadpresentfalse%used for unnumbered heads
\newif\if@bheadpresent\global\@bheadpresentfalse%

\NeedsTeXFormat{LaTeX2e}
\ProvidesClass{\classname}[\lastmodifieddate\space\versionnumber]

\setlength{\paperheight}{9truein}%
\setlength{\paperwidth}{6truein}%

\DeclareOption{draft}{\PassOptionsToPackage{draft}{graphicx}}
\DeclareOption{a4paper}{\PassOptionsToPackage{a4}{crop}}
\DeclareOption{centre}{\PassOptionsToPackage{center}{crop}}
\DeclareOption{crop}{\PassOptionsToPackage{cam}{crop}\global\@cropmarksontrue}
\DeclareOption{nocrop}{\PassOptionsToPackage{off}{crop}\global\@cropmarksonfalse}
\DeclareOption{info}{\PassOptionsToPackage{info}{crop}}
\DeclareOption{noinfo}{\PassOptionsToPackage{noinfo}{crop}}
%%Trim Sizes%%
\DeclareOption{6x9}{\global\sixbyninetrue}
\DeclareOption{7x10}{\global\sevenbytentrue}
\DeclareOption{7x10wide}{\global\sevenbytenwidetrue}
\DeclareOption{8x10}{\global\eightbytentrue%
\PassOptionsToPackage{width=9truein,height=11truein,cam}{crop}%
}%
%%Numbers like Theorem 1.1, Lemma 1.1, etc.
\DeclareOption{thmnumcontwithchapter}{\global\thmcountchaptertrue}
%%Numbers like Theorem 1.1, Lemma 1.2, etc.
\DeclareOption{thmnumcont}{\global\thmcountconttrue}%

\ExecuteOptions{a4paper,crop,centre,info}

\ProcessOptions

\ifsixbynine%
\setlength{\paperheight}{9truein}%
\setlength{\paperwidth}{6truein}%
\fi%

\ifsevenbyten%
\setlength{\paperheight}{10truein}%
\setlength{\paperwidth}{7truein}%
\fi%

\ifsevenbytenwide
\setlength{\paperheight}{10truein}%
\setlength{\paperwidth}{7truein}%
\fi%

\ifeightbyten%
\setlength{\paperheight}{10truein}%
\setlength{\paperwidth}{8truein}%
\fi%

% Load all necessary packages
\usepackage{ifxetex,ifluatex}%
\RequirePackage[T1]{fontenc}%
\ifxetex\relax\else%
%\RequirePackage{times}%
%\RequirePackage[defaultmathsizes,italic]{mathastext}
\fi%
\ifluatex\relax\else%
%\RequirePackage{times}%
%\RequirePackage[defaultmathsizes,italic]{mathastext}
\fi%
\RequirePackage{crop,graphicx,amsmath,amsthm,amsfonts,amssymb,makeidx,array,floatpag,soul}%
\RequirePackage{framed,stfloats,courier}%
\RequirePackage[figuresright]{rotating}%
\RequirePackage{adjustbox}%
\RequirePackage{titlecaps}%
\Addlcwords{the of into that for in and a with in}%%

%\usepackage{ifluatex}%
%\usepackage{ifxetex}%
%\ifxetex%

% Not sure if needed.
\newcommand\@ptsize{0}

% Set twoside printing
\@twosidetrue 

% Marginal notes are on the outside edge
\@mparswitchtrue

% Default font sizes
\def\aboveskip{%
\abovedisplayskip=0pt%
\abovedisplayshortskip=0pt%
}%

\renewcommand\normalsize{%
   \@setfontsize\normalsize{9.25\p@}{14.5\p@}%
   \abovedisplayskip 4\p@%
   \abovedisplayshortskip \z@%
   \belowdisplayshortskip 2\p@%
   \belowdisplayskip 4\p@%
   \let\@listi\@listI}%
\normalsize%
\let\@bls\baselineskip%

\newcommand\small{%
   \@setfontsize\small{9\p@}{11\p@}%
   \abovedisplayskip 8.5\p@%
   \abovedisplayshortskip \z@%
   \belowdisplayshortskip 4\p@%
   \def\@listi{\leftmargin\leftmargini
               \topsep 4\p@%
               \parsep 2\p@%
               \itemsep \parsep}%
   \belowdisplayskip \abovedisplayskip
}

\newcommand\footnotesize{%
   \@setfontsize\footnotesize{8\p@}{12\p@}%
   \abovedisplayskip 6\p@%
   \abovedisplayshortskip \z@%
   \belowdisplayshortskip 3\p@%
   \def\@listi{\leftmargin\leftmargini
               \topsep 3\p@%
               \parsep 2\p@%
               \itemsep \parsep}%
   \belowdisplayskip 6\p@
}

\newcommand\enotesize{%
   \@setfontsize\footnotesize{8\p@}{10\p@}%
   \abovedisplayskip 6\p@%
   \abovedisplayshortskip \z@%
   \belowdisplayshortskip 3\p@%
   \def\@listi{\leftmargin\leftmargini
               \topsep 3\p@%
               \parsep 2\p@%
               \itemsep \parsep}%
   \belowdisplayskip 6\p@
}

\newcommand\refsize{%
   \@setfontsize\footnotesize{8\p@}{11.5\p@}%
   \abovedisplayskip 6\p@%
   \abovedisplayshortskip \z@%
   \belowdisplayshortskip 3\p@%
   \def\@listi{\leftmargin\leftmargini
               \topsep 3\p@%
               \parsep 2\p@%
               \itemsep \parsep}%
   \belowdisplayskip 6\p@
}

\newcommand\scriptsize{\@setfontsize\scriptsize\@viipt\@viiipt}
\newcommand\tiny{\@setfontsize\tiny\@vpt\@vipt}
%\newcommand\little{\@setfontsize\tiny\@ixpt\@ixpt}
\newcommand\large{\@setfontsize\large\@xiipt{14}}
\newcommand\Large{\@setfontsize\Large\@xivpt{18}}
\newcommand\LARGE{\@setfontsize\LARGE\@xviipt{22}}
\newcommand\huge{\@setfontsize\huge\@xxpt{25}}
\newcommand\Huge{\@setfontsize\Huge\@xxvpt{30}}

\DeclareOldFontCommand{\rm}{\normalfont\rmfamily}{\mathrm}
\DeclareOldFontCommand{\sf}{\normalfont\sffamily}{\mathsf}
\DeclareOldFontCommand{\tt}{\normalfont\ttfamily}{\mathtt}
\DeclareOldFontCommand{\bf}{\normalfont\bfseries}{\mathbf}
\DeclareOldFontCommand{\it}{\normalfont\itshape}{\mathit}
\DeclareOldFontCommand{\sl}{\normalfont\slshape}{\@nomath\sl}
\DeclareOldFontCommand{\sc}{\normalfont\scshape}{\@nomath\sc}

% Line spacing
\setlength\lineskip{1\p@}
\setlength\normallineskip{1\p@}
\renewcommand\baselinestretch{}

% Paragraph dimensions and inter-para spacing
\setlength\parskip{0\p@}
\setlength\parindent{12\p@}

% Set inter-para skips
\setlength\smallskipamount{3.25\p@}
\setlength\medskipamount{6.5\p@}
\setlength\bigskipamount{13\p@}

% Page break penalties
\@lowpenalty   51
\@medpenalty  151
\@highpenalty 301

% Disallow widows and orphans
\clubpenalty 10000
\widowpenalty 10000

% Disable page breaks before equations, allow pagebreaks after
% equations and discourage widow lines before equations.
\displaywidowpenalty 100
\predisplaypenalty   10000
\postdisplaypenalty  0

% Allow breaking the page in the middle of a paragraph
\interlinepenalty 0

% Disallow breaking the page after a hyphenated line
\brokenpenalty 10000

% Hyphenation; don't split words into less than three characters
\lefthyphenmin=3
\righthyphenmin=3

\ifxetex
%\RequirePackage{mathptmx}%
\usepackage{fontspec}%
\defaultfontfeatures{Ligatures=TeX}%
\setmainfont[Mapping=tex-text,Path = ./fonts/ ,
UprightFont= StoneSerifStd-Medium,
BoldFont= StoneSerifStd-Semibold,
ItalicFont=StoneSerifStd-MediumItalic,
BoldItalicFont=StoneSerifStd-SemiboldIt,
]{StoneSerifStd}%
\setsansfont[Mapping=tex-text,Path = ./fonts/ ,
%Scale=MatchLowercase,
UprightFont= AvenirLTStd-Roman,
BoldFont=AvenirLTStd-Medium,
ItalicFont=AvenirLTStd-Oblique,
BoldItalicFont=AvenirLTStd-MediumOblique
]{SyntaxLTStd-Roman}
\newsavebox\foobox%
\newcommand{\slantbox}[2][.2]{\mbox{%
        \sbox{\foobox}{#2}%
        \hskip\wd\foobox
        \pdfsave
        \pdfsetmatrix{1 0 #1 1}%
        \llap{\usebox{\foobox}}%
        \pdfrestore
}}
\newcommand{\sfbfit}[1]{\slantbox{#1}}%
\fi

\ifluatex
\usepackage{fontspec}%
\defaultfontfeatures{Ligatures=TeX}%
\setmainfont[Mapping=tex-text,Path = ./fonts/ ,
UprightFont= StoneSerifStd-Medium,
BoldFont= StoneSerifStd-Semibold,
ItalicFont=StoneSerifStd-MediumItalic,
BoldItalicFont=StoneSerifStd-SemiboldIt
]{StoneSerifStd}%
\setsansfont[Mapping=tex-text,Path = ./fonts/ ,
%Scale=MatchLowercase,
UprightFont= AvenirLTStd-Roman,
BoldFont=AvenirLTStd-Medium,
ItalicFont=AvenirLTStd-Oblique,
BoldItalicFont=AvenirLTStd-MediumOblique
]{SyntaxLTStd-Roman}
\newsavebox\foobox%
\newcommand{\slantbox}[2][.2]{\mbox{%
        \sbox{\foobox}{#2}%
        \hskip\wd\foobox
        \pdfsave
        \pdfsetmatrix{1 0 #1 1}%
        \llap{\usebox{\foobox}}%
        \pdfrestore
}}
\newcommand{\sfbfit}[1]{\slantbox{#1}}%
\fi

%%Sansbold definitions
\newcommand{\sansbold}[1]{\textbf{\textsf{#1}}}%
\newcommand{\sansheavy}[1]{\bgroup\fontspec[ Path = ./Fonts/ ]{AvenirLTStd-Heavy}\selectfont#1\egroup}%
\newcommand{\sansmed}[1]{\bgroup\fontspec[ Path = ./Fonts/ ]{AvenirLTStd-Medium}\selectfont#1\egroup}%
\newcommand{\sansblk}[1]{\bgroup\fontspec[ Path = ./Fonts/ ]{AvenirLTStd-Black}\selectfont#1\egroup}%
\newcommand{\sansboldit}[1]{\textit{\textbf{\textsf{#1}}}}%
%%

%
% Set page layout dimensions
%
\setlength\headheight{8\p@}         % height of running head
\setlength\topmargin{33\p@}         % head margin
\addtolength\topmargin{-1in}        % subtract out the 1 inch driver margin

\setlength\topskip{7.5\p@}           % height of first line of text
\AtBeginDocument{\setlength{\topskip}{\fontcharht\font`T}}%
\setlength\headsep{39\p@}           % space below running head --
\addtolength\headsep{-\topskip}     %   base to base with first line of text

\setlength\footskip{\z@}            % space above footer line
\setlength\maxdepth{.5\topskip}     % pages can be short or deep by half a line?

\ifsixbynine
\setlength\textwidth{26pc}          % text measure excluding margins
\fi

\ifsevenbyten%
\setlength\textwidth{30pc}          % text measure excluding margins
\fi

\ifsevenbytenwide
\setlength\textwidth{30pc}          % text measure excluding margins
\fi

\ifeightbyten%
\setlength\textwidth{30pc}          % text measure excluding margins
\fi

\ifsixbynine
\setlength\textheight{35\baselineskip} % 36 lines on a full page,
\addtolength\textheight{\topskip}      %    including the first
\fi                                       %    line on the page

\ifsevenbyten
\setlength\textheight{40\baselineskip} % 41 lines on a full page,
\addtolength\textheight{\topskip}      %    including the first
\fi                                       %    line on the page

\ifeightbyten
\setlength\textheight{40\baselineskip} % 41 lines on a full page,
\addtolength\textheight{\topskip}      %    including the first
\fi                                       %    line on the page

% Set the margins
% Margin paras are not required. Set lengths to zero.
\ifsixbynine
\setlength\marginparsep{18\p@}
\setlength\marginparpush{6\p@}
\setlength\marginparwidth{40\p@}
\fi

\ifsevenbyten
\setlength\marginparsep{\z@}%
\setlength\marginparpush{\z@}%
\setlength\marginparwidth{48\p@}%
\fi

\ifsevenbytenwide
\setlength\marginparsep{18\p@}
\setlength\marginparpush{6\p@}
\setlength\marginparwidth{40\p@}
\fi

\ifeightbyten
\setlength\marginparsep{\z@}
\setlength\marginparpush{\z@}
\setlength\marginparwidth{72\p@}
\fi

%%%
\ifsixbynine
\setlength\oddsidemargin{5pc}
\addtolength\oddsidemargin{-1in}    % subtract out the 1 inch driver margin
\setlength\@tempdima{\paperwidth}
\addtolength\@tempdima{-\textwidth}
\addtolength\@tempdima{-5pc}
\setlength\evensidemargin{\@tempdima}
\addtolength\evensidemargin{-1in}
\fi

\ifsevenbyten
\setlength\oddsidemargin{6pc}
\addtolength\oddsidemargin{-1in}    % subtract out the 1 inch driver margin
\setlength\@tempdima{\paperwidth}
\addtolength\@tempdima{-\textwidth}
\addtolength\@tempdima{-6pc}
\setlength\evensidemargin{\@tempdima}
\addtolength\evensidemargin{-1in}
\fi

\ifsevenbytenwide%
\setlength\oddsidemargin{6pc}
\addtolength\oddsidemargin{-1in}    % subtract out the 1 inch driver margin
\setlength\@tempdima{\paperwidth}
\addtolength\@tempdima{-\textwidth}
\addtolength\@tempdima{-6pc}
\setlength\evensidemargin{\@tempdima}
\addtolength\evensidemargin{-1in}
\fi

\ifeightbyten%
\setlength\oddsidemargin{9pc}
\addtolength\oddsidemargin{-1in}    % subtract out the 1 inch driver margin
\setlength\@tempdima{\paperwidth}
\addtolength\@tempdima{-\textwidth}
\addtolength\@tempdima{-9pc}
\setlength\evensidemargin{\@tempdima}
\addtolength\evensidemargin{-1in}
\fi

\setlength\columnsep{0\p@}          % space between columns for double-column text
\setlength\columnseprule{0\p@}      % width of rule between two columns

% Footnotes
\setlength\footnotesep{8\p@}     % space between footnotes
% space between text and footnote
\setlength{\skip\footins}{18\p@}%

% Float placement parameters

% The total number of floats that can be allowed on a page.
\setcounter{totalnumber}{10}
% The maximum number of floats at the top and bottom of a page.
\setcounter{topnumber}{5}
\setcounter{bottomnumber}{5}
% The maximum part of the top or bottom of a text page that can be
% occupied by floats. This is set so that at least four lines of text 
% fit on the page.
\renewcommand\topfraction{.921}
\renewcommand\bottomfraction{.921}
% The minimum amount of a text page that must be occupied by text.
% This should accomodate four lines of text.
\renewcommand\textfraction{.079}
% The minimum amount of a float page that must be occupied by floats.
\renewcommand\floatpagefraction{.887}

% The same parameters repeated for double column output
\renewcommand\dbltopfraction{.88}
\renewcommand\dblfloatpagefraction{.88}

% Space between floats
\setlength\floatsep    {12\p@}
% Space between floats and text
\setlength\textfloatsep{20\p@}
% Space above and below an inline figure
\setlength\intextsep   {18\p@}

% For double column floats
\setlength\dblfloatsep    {12\p@}% \@plus 2\p@ \@minus 2\p@}
\setlength\dbltextfloatsep{20\p@}% \@plus 2\p@ \@minus 4\p@}

% Space left at top, bottom and inbetween floats on a float page.
\setlength\@fptop{0\p@}         % no space above float page figures
\setlength\@fpsep{12\p@}% \@plus 2fil}
\setlength\@fpbot{0\p@}% \@plus 1fil}

% The same for double column
\setlength\@dblfptop{0\p@}
\setlength\@dblfpsep{12\p@}% \@plus 1fil}
\setlength\@dblfpbot{0\p@}% \@plus 2fil}

% Page styles
\sodef\trackhundred{}{2\p@}{7.75\p@}{0pt}%
\sodef\trackfifty{}{1\p@}{4\p@}{0pt}%

  \def\ps@headings{%
      \let\@oddfoot\@empty\let\@evenfoot\@empty
      \def\@evenhead{%
\fontsize{7.5\p@}{7.5\p@}\selectfont{\sansbold{\thepage}}\hfill{%
\if@mainmatter{\sansbold{\MakeUppercase\chaptername~\thechapter}}\else\sansbold{\MakeUppercase\leftmark}\fi}}%
      \def\@oddhead{\fontsize{7.5\p@}{7.5\p@}\selectfont{\sansbold{\MakeUppercase\rightmark}}\hfill{\sansbold{\thepage}}
}%
      \let\@mkboth\markboth
    \def\chaptermark##1{\markboth{##1}{##1}}%
}

\def\ps@plain{%
\let\@oddfoot\relax \let\@evenfoot\relax
%  \def\@oddfoot{\hfill{{\fontsize{10\p@}{12\p@}\selectfont\thepage}}}%
  \let\@evenfoot\@oddfoot%
  \let\@oddhead\relax \let\@evenhead\relax}%
                                                                    
%          
% Sectional units
%

% Lowest level heading that takes a number by default
\setcounter{secnumdepth}{3}
    
% Counters
\newcounter{part}
\newcounter{chapter}
\newcounter{section}[chapter]
\newcounter{subsection}[section]
\newcounter{subsubsection}[subsection]
\newcounter{paragraph}[subsubsection]
\newcounter{subparagraph}[paragraph]
\newcounter{figure}[chapter]
\newcounter{table}[chapter]


% Form of the numbers
\newcommand\thepage{\arabic{page}}
\renewcommand\thepart{\Roman{part}}
\renewcommand\thechapter{\arabic{chapter}}
\renewcommand\thesection{\thechapter.\arabic{section}}
\renewcommand\thesubsection{\thesection.\arabic{subsection}}
\renewcommand\thesubsubsection{\thesubsection.\arabic{subsubsection}}%
\renewcommand\theparagraph{\thesubsubsection.\arabic{paragraph}}
\renewcommand\thesubparagraph{\theparagraph.\arabic{subparagraph}}
\renewcommand\theequation{\thechapter.\arabic{equation}}
\newcommand\@chapapp{\chaptername}

% Form of the words
\newcommand\contentsname{Contents}
\newcommand\listfigurename{List of Figures}
\newcommand\listtablename{List of Tables}
\newcommand\partname{Part}
\newcommand\chaptername{Chapter}
\newcommand\appendixname{Application}
\newcommand\abstractname{Abstract}
\newcommand\refname{References}
\newcommand\bibname{Bibliography}
\newcommand\indexname{Index}
\newcommand\figurename{Figure}
\newcommand\tablename{Table}

% Clearemptydoublepage should really clear the running heads too
\newcommand{\clearemptydoublepage}{\newpage{\pagestyle{empty}\cleardoublepage}}

% Frontmatter, mainmatter and backmatter

\newif\if@mainmatter \@mainmattertrue

\newcommand\frontmatter{%
  \clearpage
  \@mainmatterfalse
  \pagenumbering{roman}}

\newcommand{\HalfTitle}[1]{\thispagestyle{empty}\bgroup\parindent\z@\raggedright%
\null\vspace{43.85\p@}%
\vbox to 79\p@{%
\fontsize{20.75}{24}\selectfont%
\sansheavy{\uppercase{\trackhundred{#1}}}\par%
\vfill%
}%
\rule{\textwidth}{0.25\p@}\par%
\removelastskip\nointerlineskip\vspace{0.5\p@}\nointerlineskip%
\rule{\textwidth}{0.25\p@}\par%
\egroup\clearpage}%

\newcommand{\halftitlepage}{}%

\newcommand{\doublerule}{\rule{\textwidth}{0.25\p@}\par%
\removelastskip\nointerlineskip\vspace{0.5\p@}\nointerlineskip%
\rule{\textwidth}{0.25\p@}\par%
}%

\def\seriespage{\thispagestyle{empty}\parindent=0pt\parskip=0pt
\null\vspace{38.25\p@}%
\fontsize{8}{10}\selectfont%
\def\title##1{\fontsize{8}{12}\fontshape{it}\selectfont%
\vskip6pt{##1}}%
\def\author##1{\fontsize{8}{12}\selectfont%
\vspace{-2\p@}\vskip1sp{\rm ##1}\vspace{7\p@}}%
}
\def\endseriespage{\newpage}
\def\seriestitle#1{{\fontsize{8}{12}\selectfont\sansheavy{#1}}\vskip-2\p@}%
\def\serieseditor#1{\vskip2\p@{\fontsize{8}{10}\selectfont#1}\vspace{4\p@}}

\newcommand{\Title}[1]{\thispagestyle{empty}\bgroup\parindent\z@\raggedright%
\null\vspace{43.85\p@}%
\vbox to 79\p@{%
\fontsize{20.75}{24}\selectfont%
\sansheavy{\uppercase{\trackhundred{#1}}}\par%
\vfill%
}%
\rule{\textwidth}{0.25\p@}\par%
\removelastskip\nointerlineskip\vspace{0.5\p@}\nointerlineskip%
\rule{\textwidth}{0.25\p@}\par%
\egroup}%

\newcommand{\Booksubtitle}[1]{\thispagestyle{empty}\bgroup\parindent\z@\raggedright%
\vspace{10.5\p@}%
\fontsize{11\p@}{14\p@}\selectfont%
\sansheavy{\uppercase{#1}}\par%
\egroup}%

\newcommand{\edition}[1]{\bgroup\parindent\z@\raggedright%
\vspace{7.5\p@}%
\normalsize%
\sansbold{#1\vphantom{y}}\par%
\egroup}%

\newcommand{\BookAuthor}[1]{\bgroup\parindent\z@\raggedright%
\vspace{40.5\p@}%
\fontsize{10}{14}\selectfont%
\sansheavy{\uppercase{{#1}}}\par%
\egroup}

\newcommand{\imprint}[1]{\bgroup\parindent\z@\raggedright%
\vfill%
\fontsize{7}{12}\selectfont\sf\uppercase{#1}\par%
\egroup\newpage}%

\newenvironment{copyrightpage}{\thispagestyle{empty}\bgroup\parindent\z@%
\raggedright%
\fontsize{8\p@}{12\p@}\selectfont%
\null\vfill%
\setlength{\parskip}{12\p@}%
}{\par\egroup\newpage}%

\newcommand{\dedication}[1]{\thispagestyle{empty}\bgroup\parindent\z@\raggedright%
\null\vspace{202\p@}%
\normalsize%
#1\par%
\egroup}

\def\startonoddpage{\clearpage
\ifodd\c@page\else\null\thispagestyle{empty}\newpage\fi}

\newenvironment{epigraphpage}{\thispagestyle{empty}%
\startonoddpage\bgroup%
\null\vspace{204\p@}%
\fontsize{8.5}{12}\selectfont%
}{\egroup\thispagestyle{empty}\newpage}%

\def\epigraph#1#2{\noindent{\fontsize{8.5}{12}\selectfont#1\vphantom{y}}\vskip2\p@%
\noindent{\fontsize{8.5}{12}\selectfont---#2}\vskip12pt}%

\newenvironment{contributors}{\bgroup%
\chapter*{Contributors}%
\addcontentsline{toc}{fmbm}{Contributors}%
\fontsize{8}{12}\selectfont%
\def\contrib##1##2{\noindent\sansheavy{##1}~{##2}\par\vspace{6\p@}}%
}{\par\egroup}

%%%
\newcommand\mainmatter{%
  \clearpage
  \@mainmattertrue
  \pagenumbering{arabic}
\let\epigraph\chapepigraph%
}

\newcommand\backmatter{%
  \clearpage
  \@mainmatterfalse}

\def\part{\clearpage\thispagestyle{empty}\global\@topnum\z@
  \secdef\@part\@spart}

\def\@part[#1]#2{%
  \ifnum \c@secnumdepth >\m@ne
    \refstepcounter{part}
%    \typeout{^^J\@chapapp\space\arabic{chapter}:}
    \addcontentsline{toc}{part}{\protect\numberline{\thepart}#2}
  \else
    \addcontentsline{toc}{part}{#2}
  \fi
  \@makeparthead{#2}
  \@afterindentfalse
  \@afterheading}
        
\def\@spart#1{%
  \thispagestyle{empty}
  \@makesparthead{#1}
  \@afterindentfalse
  \@afterheading}

\def\chapter{\clearpage\startonoddpage\thispagestyle{plain}\global\@topnum\z@
  \secdef\@chapter\@schapter}

\def\@chapter[#1]#2{%
  \ifnum \c@secnumdepth >\m@ne
    \refstepcounter{chapter}
    \typeout{^^J\@chapapp\space\arabic{chapter}:}
    \addcontentsline{toc}{chapter}{\protect\numberline{\thechapter}#2}
  \else
    \addcontentsline{toc}{chapter}{#2}
  \fi
  \chaptermark{#1}
  \@makechapterhead{#2}
  \@afterindentfalse
  \@afterheading\chapterauthor{}\subtitle{}\notenum=0%
}
        
\def\@schapter#1{%
  \chaptermark{#1}
  \thispagestyle{plain}
  \@makeschapterhead{#1}
  \@afterindentfalse
  \@afterheading}

\def\@makeparthead#1{% 
  \begingroup%
    \parindent\z@\raggedright%
\null\vspace{-5.5\p@}%
\vbox to 127\p@{%
\hskip-4\p@\fontsize{48}{48}\selectfont\sansheavy{\thepart}\par%
\vspace{16\p@}%
    {\fontsize{15\p@}{16\p@}\selectfont\sansheavy{\uppercase{\trackhundred{#1}}}\par}%
\vspace{-19\p@}%
\vfill}%
\doublerule%
  \endgroup
  \@afterindentfalse
  \@afterheading
\clearemptydoublepage%
}

\def\partintro{\startonoddpage%
\bgroup%
\setcounter{secnumdepth}{0}%
\thispagestyle{empty}%
\normalsize%
}

\def\endpartintro{\egroup\newpage%
\setcounter{secnumdepth}{3}%
}%

\def\partintrotitle#1{\section*{#1}%
\addcontentsline{toc}{section}{#1}%
}

\let\@chapterauthor\@empty%
\def\chapterauthor#1{\def\@chapterauthor{#1}}%

\let\@subtitle\@empty%
\def\subtitle#1{\def\@subtitle{\uppercase{\trackhundred{#1}}}}%

\def\@makechapterhead#1{% 
  \begingroup%
    \parindent\z@\raggedright%
\null\vspace{-5.5\p@}%
\vbox to 207\p@{%
\vbox to 128\p@{%
\fontsize{48\p@}{48\p@}\selectfont\sansheavy{\thechapter}\par%
\vspace{16\p@}%
\ifx\@subtitle\@empty
    {\fontsize{15\p@}{18\p@}\selectfont\sansheavy{\uppercase{\trackhundred{#1}}}\par}%
\else%
    {\fontsize{15\p@}{18\p@}\selectfont\sansheavy{\uppercase{\trackhundred{#1}}}%
{\fontsize{15\p@}{18\p@}\selectfont\sansheavy{\uppercase{\@subtitle}}}%
\par}\fi%
%\ifx\@subtitle\@empty\relax\else%
%\vspace{4\p@}%
%{\fontsize{11}{14.5}\selectfont\@subtitle\par}\fi%
\ifx\@chapterauthor\@empty\relax\else%
\vspace{11\p@}%
\addcontentsline{toc}{contributor}{\@chapterauthor}\fi%
 {\fontsize{9.75\p@}{14\p@}\selectfont\sansheavy{\@chapterauthor\vphantom{y}}\par}%
\vfill}%
\doublerule%
\vfill}  \endgroup%
  \@afterindentfalse
  \@afterheading}

\def\abstract{\vskip9pt\bgroup\small\noindent{\sansbold{Abstract.}}\ignorespaces\hspace{9\p@}\ignorespaces}%
\def\endabstract{\vskip1sp\egroup\vskip9pt}%

\def\chapepigraph#1#2{\noindent{\fontsize{8.5}{12.5}\selectfont#1\vphantom{y}}\vskip-1\p@%
\noindent{\fontsize{8.5}{12.5}\selectfont---#2}\vskip9pt}%

\def\endchapepigraph{\vspace{4.5\p@}}%

%%%%Appendix Chapter Title
\def\@makeappchapterhead#1{% 
  \begingroup%
    \parindent\z@\raggedright%
\null\vspace{-5.5\p@}%
\vbox to 207\p@{%
\vbox to 128\p@{%
\fontsize{48\p@}{48\p@}\selectfont\sansheavy{\thechapter}\par%
\vspace{16\p@}%
    {\fontsize{15\p@}{18\p@}\selectfont\sansheavy{\uppercase{\trackhundred{#1}}}\par}%
\ifx\@subtitle\@empty\relax\else%
\vspace{6\p@}%
{\fontsize{11}{14.5}\selectfont\@subtitle\par}\fi%
\ifx\@chapterauthor\@empty\relax\else%
\vspace{11\p@}%
\addcontentsline{toc}{contributor}{\@chapterauthor}\fi%
 {\fontsize{9.75\p@}{14\p@}\selectfont\sansheavy{\@chapterauthor\vphantom{y}}\par}%
\vfill}%
\doublerule%
\vfill}  \endgroup%
  \@afterindentfalse\notenum=0%
  \@afterheading}

  
\def\@makeschapterhead#1{% 
  \begingroup%
    \parindent\z@\raggedright%
\null\vspace{-5.5\p@}%
\vbox to 207\p@{%
\vbox to 128\p@{%
\fontsize{48\p@}{48\p@}\selectfont\sansbold{\hphantom{2}}\par%
\vspace{46\p@}%
    {\fontsize{15\p@}{18\p@}\selectfont\sansheavy{\uppercase{\trackhundred{#1}}}\par}%
\vfill}%
\doublerule%
\vfill}  \endgroup\notenum=0\setcounter{footnote}{0}%
  \@afterindentfalse
  \@afterheading}


% Section macros

% \@sect redefined to write the long entry to the TOC
\def\@sect#1#2#3#4#5#6[#7]#8{%
  \ifnum #2>\c@secnumdepth
    \let\@svsec\@empty
  \else
    \refstepcounter{#1}%
    \protected@edef\@svsec{\@seccntformat{#1}\relax}%
  \fi
  \@tempskipa #5\relax
  \ifdim \@tempskipa>\z@
    \ifnum#2=1%
    \begingroup
      #6{%
        \@hangfrom{\hskip #3\relax\@svsec}%
          \interlinepenalty \@M \sansheavy{\uppercase{#8}} \@@par}%
    \endgroup\else
    \ifnum#2=2%
    \begingroup
      #6{%
        \@hangfrom{\hskip #3\relax\@svsec}%
          \interlinepenalty \@M \sansmed{\uppercase{#8}} \@@par}%
    \endgroup\else%
    \begingroup
      #6{%
        \@hangfrom{\hskip #3\relax\@svsec}%
          \interlinepenalty \@M #8 \@@par}%
    \endgroup\fi\fi
    \csname #1mark\endcsname{#7}%
    \addcontentsline{toc}{#1}{%
      \ifnum #2>\c@secnumdepth \else
        \protect\numberline{\csname the#1\endcsname}%
      \fi
      #8}%
  \else
    \def\@svsechd{%
      #6{\hskip #3\relax
      \@svsec #8}%
      \csname #1mark\endcsname{#7}%
      \addcontentsline{toc}{#1}{%
        \ifnum #2>\c@secnumdepth \else
          \protect\numberline{\csname the#1\endcsname}%
        \fi
        #8}}%
  \fi
  \@xsect{#5}}

\def\@ssect#1#2#3#4#5{\@tempskipa #3\relax
   \ifdim \@tempskipa>\z@
     \begingroup
         %\ifnum#1=3%
%         #4\@hangfrom{\hskip #1}%
%         {\interlinepenalty \@M {#5}\par}
%         \else%
         \if@aheadpresent\global\@aheadpresenttrue%
         #4\@hangfrom{\hskip #1}%
         {\interlinepenalty \@M {{\sansheavy{#5}}\par}}
         \else
         \if@bheadpresent\global\@bheadpresenttrue%
         #4\@hangfrom{\hskip #1}%
         {\interlinepenalty \@M {{\sansmed{#5}}}\par}
         \else
         #4\@hangfrom{\hskip #1}%
         {\interlinepenalty \@M \sansheavy{#5}\par}
         \fi%
         \fi%
%         \fi%
         \endgroup%
   \else
      \def\@svsechd{#4\hskip #1\relax #5\@afterhead}\fi
    \@xsect{#3}\global\@aheadpresentfalse\global\@bheadpresentfalse}

\newdimen\bsecdimen%
\bsecdimen=22pt%%%

\newdimen\asecdimen%
\asecdimen=7pt%

\renewcommand{\@seccntformat}[1]{{\sansheavy{\csname the#1\endcsname}\ignorespaces\hspace{9pt}\ignorespaces}}%
\newcommand\section{
\def\@seccntformat##1{{\sansheavy{\csname the##1\endcsname}\ignorespaces\hspace{9pt}\ignorespaces}}%
\@startsection {section}{1}{\z@}%
                                   {-\bsecdimen}%
                                   {\asecdimen}
{\fontsize{9\p@}{14\p@}\selectfont\raggedright}}

\newdimen\bsubsecdimen% B and C level above spaces are same
\bsubsecdimen=22pt%%

\newdimen\asubsecdimen%
\asubsecdimen=0.01pt%%

\newcommand\subsection{%
\def\@seccntformat##1{{\sansmed{\csname the##1\endcsname}\ignorespaces\hspace{9pt}\ignorespaces}}%
\@startsection{subsection}{2}{\z@}%
                                     {-\bsubsecdimen}%
                                     {\asubsecdimen}%
{\fontsize{9\p@}{14\p@}\selectfont\raggedright}}

\newcommand\subsubsection{
\def\@seccntformat##1{{\sansheavy{\csname the##1\endcsname}\ignorespaces\hspace{9pt}\ignorespaces}}%
\@startsection{subsubsection}{3}{\z@}%
                                     {-4\p@}%
                                     {-9\p@}%
{\fontsize{9\p@}{13\p@}\selectfont\raggedright\sansheavy}}

\newcommand\paragraph{\@startsection{paragraph}{4}{\z@}%
                                     {-4\p@}%
                                     {-9\p@}%
{\fontsize{9.25\p@}{14.5\p@}\fontshape{it}\selectfont\raggedright}}

\newcommand\subparagraph{\@startsection{subparagraph}{5}{\z@}%
                                     {-7\p@}%
                                     {-9\p@}%
{\fontsize{9\p@}{13\p@}\selectfont\raggedright}}

\newlength\abovecaptionskip
\newlength\belowcaptionskip
\setlength\abovecaptionskip{5\p@}
\setlength\belowcaptionskip{\z@}

\long\def\@makecaption#1#2{\vspace{\abovecaptionskip}%
\fontsize{8\p@}{12\p@}\sf\selectfont%
  \setbox\@tempboxa=\hbox{#1\ignorespaces\hspace{1em}\ignorespaces#2}%
  {\sansheavy{#1}}\ignorespaces\hspace{8\p@}\ignorespaces#2%
}

\long\def\@tablecaption#1#2{\fontsize{8\p@}{12\p@}\selectfont%
{\sansblk{#1}}\ignorespaces\hspace{8\p@}\ignorespaces{#2\strut}\par
  \vspace{\belowcaptionskip}}

\newcommand{\tabfont}{\fontsize{8}{10}\selectfont}%

\newcommand{\colhead}[1]{\sansheavy{#1}}%

% Top rule
\RequirePackage{threeparttable,booktabs}%

\def\hrulefill{\leavevmode\leaders\hrule height .50pt\hfill\kern\z@}
\def\foothrulefill{\leavevmode\leaders\hrule height .25pt\hfill\kern\z@}

\def\thefigure{\thechapter.\@arabic\c@figure}
\def\fps@figure{tbp}
\def\ftype@figure{1}
\def\ext@figure{lof}
%\def\fnum@figure{\figurename~\thefigure}
\def\fnum@figure{\thefigure}
\def\figure{\@float{figure}}
\def\endfigure{\end@float}
\@namedef{figure*}{\@dblfloat{figure}}
\@namedef{endfigure*}{\end@dblfloat}
\def\thetable{\thechapter.\@arabic\c@table}
\def\fps@table{tbp}
\def\ftype@table{2}
\def\ext@table{lot}
\def\fnum@table{\tablename~\thetable}
\def\table{\let\@makecaption\@tablecaption\@float{table}}
\let\endtable\end@float
\@namedef{table*}{\let\@makecaption\@tablecaption\@dblfloat{table}}
\@namedef{endtable*}{\end@dblfloat}

\newif\if@rotate \@rotatefalse
\newif\if@rotatecenter \@rotatecenterfalse
\def\rotatecenter{\global\@rotatecentertrue}
\def\rotateendcenter{\global\@rotatecenterfalse}
\def\rotate{\global\@rotatetrue}
\def\endrotate{\global\@rotatefalse}
\newdimen\rotdimen
\def\rotstart#1{\special{ps: gsave currentpoint currentpoint translate
    #1 neg exch neg exch translate}}
\def\rotfinish{\special{ps: currentpoint grestore moveto}}
\def\rotl#1{\rotdimen=\ht#1\advance\rotdimen by \dp#1
    \hbox to \rotdimen{\vbox to\wd#1{\vskip \wd#1
    \rotstart{270 rotate}\box #1\vss}\hss}\rotfinish}
\def\rotr#1{\rotdimen=\ht #1\advance\rotdimen by \dp#1
    \hbox to \rotdimen{\vbox to \wd#1{\vskip \wd#1
    \rotstart{90 rotate}\box #1\vss}\hss}\rotfinish}

\newdimen\tempdime
\newbox\temptbox
\newenvironment{processtable}[3]{\setbox\temptbox=\hbox{\fontsize{9\p@}{11\p@}\selectfont{#2}}%
\tempdime\wd\temptbox\@processtable{#1}{#2}{#3}{\tempdime}}
{\relax}

\newenvironment{@processtable}[4]{%
\if@rotate
\setbox4=\vbox to \textwidth{\vss\hbox to \textheight{\hss%
\begin{minipage}{#4}%
\fontsize{9\p@}{10\p@}\selectfont
\caption{#1}{#2}%
\vskip4pt\noindent
\parbox{#4}{\fontsize{8\p@}{10\p@}\selectfont #3\par}%
\end{minipage}}\vss}%
\else
\setbox4=\hbox to \textwidth{\vbox{\begin{center}\begin{minipage}[t]{#4}%
\fontsize{9\p@}{10\p@}\selectfont
\caption{#1}{#2}%
\vskip4pt\noindent
\parbox{#4}{\fontsize{8\p@}{10\p@}\selectfont #3\par}%
\end{minipage}\end{center}}}%
\fi
\if@rotate\rotl{4}\else\box4\fi}
{\relax}

\newcolumntype{P}[1]{>{\raggedright\arraybackslash}p{#1}}%

% ******************************
% List numbering and lettering *
% ******************************
\def\labelenumi{{\rm\arabic{enumi}.}}
\def\theenumi{\arabic{enumi}}
\def\labelenumii{{\rm \roman{enumii}.}}
\def\theenumii{a\alph{enumii}}
\def\p@enumii{\theenumi}
\def\labelenumiii{({\rm\roman{enumiii}})}
\def\theenumiii{\roman{enumiii}}
\def\p@enumiii{\theenumi(\theenumii)}
\def\labelenumiv{({\rm\Alph{enumiv}})}
\def\theenumiv{\Alph{enumiv}}
\def\p@enumiv{\p@enumiii\theenumiii}

\newcommand{\alphlist}{%
\def\labelenumi{{\rm\alph{enumi}}}%
\def\theenumi{\alph{enumi}}%
}

\newcommand{\Alphlist}{%
\def\labelenumi{{\rm\Alph{enumi}}}%
\def\theenumi{\Alph{enumi}}%
}

\newcommand{\romanlist}{%
\def\labelenumi{{\rm\roman{enumi}}}%
\def\theenumi{\roman{enumi}}%
}

\newcommand{\Romanlist}{%
\def\labelenumi{{\rm\Roman{enumi}}}%
\def\theenumi{\Roman{enumi}}%
}

\def\labelitemi{\tiny\raise1.25pt\llap{$\bullet$}}%
\def\labelitemii{--}%
\def\labelitemiii{$\ast$}%
\def\labelitemiv{$\cdot$}%

      
\setlength\leftmargini   {\z@}%
\leftmargin  \leftmargini
\setlength\leftmarginii  {\z@}
\setlength\leftmarginiii {\z@}
\setlength\leftmarginiv  {\z@}
\setlength\leftmarginv   {\z@}
\setlength\leftmarginvi  {\z@}

\setlength\partopsep{\z@}
\setlength  \labelsep  {.5em}
\setlength  \labelwidth{\leftmargini}
\addtolength\labelwidth{-\labelsep}

\def\@listi{\leftmargin\leftmargini
            %\parsep 4\p@ \@plus2\p@ \@minus\p@
            \topsep 4\p@%
            %\itemsep4\p@ \@plus2\p@ \@minus\p@
            }
\let\@listI\@listi
\@listi
\def\@listii {\leftmargin\leftmarginii
              \labelwidth\leftmarginii
              \advance\labelwidth-\labelsep
              \topsep   \z@% 4\p@ \@plus2\p@ \@minus\p@
              \parsep    \z@%
              \itemsep   \parsep}
\def\@listiii{\leftmargin\leftmarginiii
              \labelwidth\leftmarginiii
              \advance\labelwidth-\labelsep
              \topsep    \z@%
              \parsep    \z@
              \partopsep \p@%
              \itemsep   \topsep}
\def\@listiv {\leftmargin\leftmarginiv
              \labelwidth\leftmarginiv
              \advance\labelwidth-\labelsep}
\def\@listv  {\leftmargin\leftmarginv
              \labelwidth\leftmarginv
              \advance\labelwidth-\labelsep}
\def\@listvi {\leftmargin\leftmarginvi
              \labelwidth\leftmarginvi
              \advance\labelwidth-\labelsep}

\def\enumargs{%
   \partopsep     \z@
   \itemsep       \z@
   \parsep        \z@
   \labelsep      4\p@
   \rightmargin   \z@
   \listparindent \parindent
   \itemindent    \z@}

\def\enumerate{%
    \@ifnextchar[{\@numerate}{\@numerate[0.]}}

\def\@numerate[#1]{%
     \ifnum \@enumdepth >3 \@toodeep\else
     \advance\@enumdepth \@ne
     \edef\@enumctr{enum\romannumeral\the\@enumdepth}
     \list{\csname label\@enumctr\endcsname}{%
       \enumargs
       \setlength{\leftmargin}{\csname leftmargin\romannumeral\the\@enumdepth\endcsname}
       \usecounter{\@enumctr}
       \settowidth\labelwidth{#1}
       \addtolength{\leftmargin}{\labelwidth}
       \addtolength{\leftmargin}{\labelsep}
       \def\makelabel##1{\hss\llap{##1}}}%
     \fi
   }
\let\endenumerate\endlist


% Changes to the list parameters for itemize
\def\itemargs{%
   \partopsep     \z@
   \itemsep       \z@
   \parsep        \z@
   \labelsep      7\p@
   \rightmargin   \z@
   \listparindent \parindent
   \itemindent    \z@}

\def\itemize{%
   \@ifnextchar[{\@itemize}{\@itemize[$\bullet$]}}

\def\@itemize[#1]{%
     \ifnum \@itemdepth >3 \@toodeep\else
     \advance\@itemdepth \@ne
     \edef\@itemctr{item\romannumeral\the\@itemdepth}
     \list{\csname label\@itemctr\endcsname}{%
       \itemargs
       \setlength{\leftmargin}{\csname leftmargin\romannumeral\the\@itemdepth\endcsname}
       \settowidth\labelwidth{#1}
       \addtolength{\leftmargin}{\labelwidth}
       \addtolength{\leftmargin}{\labelsep}
       \def\makelabel##1{\hss \llap{##1}}}%
     \fi
   }
\let\enditemize\endlist

\def\unargs{%
   \partopsep     \z@
   \itemsep       \z@
   \labelwidth    \z@
   \parsep        \z@
   \labelsep      \z@
   \rightmargin   \z@
   \listparindent \parindent
   \leftmargin 12pt
   \itemindent -6pt}

\newenvironment{unlist}{%
\begin{list}{}{%
  \unargs%
  }}{\end{list}}

\newenvironment{description}
               {\list{}{\topsep7.5\p@\leftmargin12\p@\itemsep\z@\labelwidth\z@ \itemindent-\leftmargin
                        \let\makelabel\descriptionlabel}}
               {\endlist}
\newcommand*\descriptionlabel[1]{\hspace\labelsep
                                \normalfont\sansbold{#1}}
\newenvironment{verse}
               {\let\\\@centercr
                \list{}{\itemsep      \z@
                        \itemindent   -1.5em%
                        \listparindent\itemindent
                        \rightmargin  \leftmargin
                        \advance\leftmargin 1.5em}%
                \item\relax}
               {\endlist}
\newenvironment{quotation}
               {\list{}{\listparindent 1.5em%
                        \itemindent    \listparindent
                        \rightmargin   \leftmargin
                        \parsep        \z@}%
                \item\relax}
               {\endlist}
\def\extitemargs{%
\topsep 7\p@%
   \partopsep     \z@%
   \itemsep       \z@%
   \parsep        \z@%
   \labelsep      0.5em%
   \rightmargin   \z@%
   \listparindent \parindent%
   \itemindent    \z@}%

\newenvironment{quote}
               {\list{}{\topsep7\p@\leftmargin12pt\rightmargin\z@\itemindent-5.25\p@\listparindent9\p@}%
                \fontsize{8.75}{12}\selectfont\let\itemargs\extitemargs%
                \item\relax}%
               {\vspace{-2.5pt}\endlist}
\let\extract\quote%
\let\endextract\endquote%

\newenvironment{boxquote}
               {\list{}{\vspace{6\p@}\topsep7\p@\leftmargin12pt\rightmargin\z@\itemindent-5.25\p@\listparindent9\p@}%
                \fontsize{8.75}{12}\selectfont\let\itemargs\extitemargs%
                \item\relax}%
               {\vspace{-2.5pt}\endlist}

\newenvironment{enotequote}
               {\list{}{\topsep4\p@\leftmargin18pt\rightmargin15\p@\itemindent-5.25\p@\listparindent9\p@\parsep\z@}%
                \scriptsize\let\itemargs\extitemargs%
                \item\relax}%
               {\endlist}

\newenvironment{appquote}
               {\list{}{\topsep2\p@\leftmargin15pt\rightmargin15\p@\itemindent-5.25\p@}%
                \fontsize{8\p@}{12\p@}\selectfont%
                \item\relax}%
               {\endlist}

\skip\@mpfootins = \skip\footins
\fboxsep=6\p@
\fboxrule=1\p@

%%Boxed text%%
%% Boxed Text
\newcounter{boxtextnum}
\@addtoreset{boxtextnum}{chapter}


\def\bsection#1{\global\advance\c@section by 1
\vspace{6pt}%
\vskip1sp\vspace{0.01\p@}\noindent{\fontsize{8}{12}\selectfont\sansheavy{\thesection}\hskip4pt
\sansheavy{#1}}\\[6\p@]}

\def\csection#1{\vskip1sp\noindent{\fontsize{8}{9}\selectfont\sansbold{#1}}\\ }
\def\csubsection#1{\vskip1sp\noindent{\fontsize{8}{9}\selectfont\sansbold{#1}}\\ }
\def\csubsubsection#1{\vskip1sp\noindent{\fontsize{8}{9}\selectfont\sansbold{#1}}\\ }

\def\bsubsection#1{\global\advance\c@subsection by 1
\vspace{6pt}%
\vskip1sp\vspace{0.01\p@}\noindent{\fontsize{8}{12}\selectfont\sansheavy{\thesubsection}\hskip4pt
\sansheavy{#1}}\\ }

\def\bsubsubsection#1{\global\advance\c@subsubsection by 1
\vspace{6pt}%
\vskip1sp\vspace{4\p@}\noindent{\fontsize{8}{9}\selectfont\sansbold{\thesubsubsection}\hskip4pt
\sansbold{#1}}\\ }

\def\xstar{*}

\def\boxedtext#1{%
\vskip15pt
\def\paragraph{\@startsection{paragraph}{4}{\z@}%
                                    {-1sp}%
                                    {-1em}%
                               {\reset@font\small\bfseries}}
\c@section=0
\c@subsection=0
\c@subsubsection=0
%%
\def\thesection{\arabic{section}}
\def\thesubsection{\thesection.\arabic{subsection}}
\def\thesubsubsection{\thesubsection.\arabic{subsubsection}}
\let\section\bsection
\let\subsection\bsubsection
\let\subsubsection\bsubsubsection
\let\small\footnotesize%
%%
\def\section##1{\def\one{##1}\ifx\one\xstar\let\go\csection\else\def\go{\bsection{##1}}\fi\go}
\def\subsection##1{\def\one{##1}\ifx\one\xstar\let\go\csubsection\else\def\go{\bsubsection{##1}}\fi\go}
\def\subsubsection##1{\def\one{##1}\ifx\one\xstar\let\go\csubsubsection\else\def\go{\bsubsubsection{##1}}\fi\go}
%%
\def\extract{\vspace{6\p@}\leftskip=12pt \rightskip\leftskip\fontsize{7}{10}\selectfont\noindent}%
\def\endextract{\vspace{6\p@}\vskip-2pt}%

\global\advance\c@boxtextnum by 1
\FrameSep=1pc%
\fboxsep=1pc \fboxrule=.5pt \framed\footnotesize
%\parskip=6pt %\parindent=0pt
\noindent\sansheavy{Box \arabic{chapter}.\arabic{boxtextnum}\\
#1\@afterheading\@afterindentfalse%
\vskip3pt\@afterheading\@afterindentfalse%
}}

\def\endboxedtext{\endframed\vspace{12\p@}}%
%%%

\definecolor{shadecolor}{cmyk}{0,0,0,0.20}%
\newenvironment{shdadeboxedtext}{\begingroup%
\begin{shaded}%
\advance\hsize by -2\FrameSep%
\@afterheading%
}{\end{shaded}\endgroup}%

%%
\newenvironment{thebibliography}[1]
     {\chapter*{\refname}%
\addcontentsline{toc}{fmbm}{\refname}%
      \list{\@biblabel{\@arabic\c@enumiv}}%
           {\settowidth\labelwidth{\@biblabel{#1}}%
            \leftmargin\labelwidth
            \advance\leftmargin\labelsep
            \@openbib@code
            \usecounter{enumiv}%
            \let\p@enumiv\@empty
            \renewcommand\theenumiv{\@arabic\c@enumiv}}%
      \clubpenalty10000
      \@clubpenalty \clubpenalty
      \widowpenalty10000%
      \sfcode`\.\@m}
     {\def\@noitemerr
       {\@latex@warning{Empty `thebibliography' environment}}%
      \endlist}
\let\@openbib@code\@empty%

\newenvironment{unnumbibliography}[1]{%
 \chapter*{\refname}%
\addcontentsline{toc}{fmbm}{\refname}%
\normalsize\list{}{%
  \usecounter{enumi}%
  \leftmargin 1em\itemindent -1em\parsep \z@
    \itemsep\z@%
 }}%
{\endlist}%


\RequirePackage{multicol}

\newif\if@restonecol
\def\theindex{\@mainmatterfalse
%  \addcontentsline{toc}{chapter}{Index}
  \columnseprule \z@
  \columnsep 12pt\begin{multicols*}{2}[\chapter*{Index}\vspace{-11\p@}] 
                                %Subject or Author here
  \markboth{\indexname}{\indexname}%
  \parskip\z@\relax\let\item\idxitem\fontsize{8\p@}{12\p@}\selectfont}
\def\idxitem{\par\noindent\raggedright\hangindent12\p@}%
\def\subitem{\par\noindent\raggedright\hangindent12\p@\hspace*{6\p@}}%
\def\subsubitem{\par\noindent\raggedright\hangindent12\p@\hspace*{12\p@}}%
\def\endtheindex{\end{multicols*}}
\def\indexspace{\par \vskip 12\p@\relax}
\AtBeginDocument{%
\def\printindex#1#2{\@restonecoltrue\if@twocolumn\@restonecolfalse\fi
  \columnseprule \z@ \columnsep 12pt%
  \newpage\startonoddpage %\twocolumn[{\Large\bf #2 \vskip4ex}]
\begin{multicols*}{2}[\chapter*{#2}\vspace{-11\p@}]%
\markboth{#2}{#2}%
  \addcontentsline{toc}{fmbm}{#2}
  \@input{#1.ind}\end{multicols*}}
%%
\def\theindex{\@mainmatterfalse
%  \addcontentsline{toc}{chapter}{Index}
  \columnseprule \z@
  \columnsep 12pt%\begin{multicols*}{2}[\chapter*{Index}] 
                                %Subject or Author here
  \markboth{\indexname}{\indexname}%
  \parskip\z@\relax\let\item\idxitem\fontsize{8\p@}{12\p@}\selectfont}%
\def\idxitem{\par\noindent\raggedright\hangindent12\p@}%
\def\subitem{\par\noindent\raggedright\hangindent12\p@\hspace*{6\p@}}%
\def\subsubitem{\par\noindent\raggedright\hangindent12\p@\hspace*{12\p@}}%
\def\endtheindex{}%\end{multicols*}}
\def\indexspace{\par \vskip 12\p@\relax}
%%
}%
     
% ***********
% Footnotes *
% ***********

\renewcommand\footnoterule{\hbox to 6pc{\foothrulefill}\par\removelastskip\nointerlineskip\vskip3.5pt\nointerlineskip}%

\usepackage[splitrule]{footmisc}%
  \def\splitfootnoterule{\kern-3\p@ \hbox to 0.5\textwidth{\hrulefill} \kern3.6\p@}

\AtBeginDocument{\renewcommand\@makefntext[1]{%
    \fontsize{8\p@}{11\p@}\selectfont\def\@textsuperscript{}%\global\baselineskip=9pt%
    \parindent10pt%
    \noindent\ignorespaces%\hspace*{10pt}\ignorespaces
    \hbox{\@makefnmark.}\ignorespaces\hspace{4\p@}\ignorespaces#1}
}%
\def\@makefnmark{\hbox{\smash{\@textsuperscript{\normalfont\@thefnmark}}}}
\@addtoreset{footnote}{chapter}%

%%End Note Definition%%%
\newcount\notenum
\newcount\endnotenum

\def\enotenumstyle{$^{\the\notenum}$}%
\newcommand{\enoteheadfont}{\fontsize{7.75}{12}\selectfont}%
\newcommand{\notename}{\trackfifty{NOTES FOR}}%
\newcommand{\eNchapter}{\renewcommand{\thechapter}{\arabic{chapter}}%
\trackfifty{CHAPTER \thechapter}\addtocounter{chapter}{1}}
\newcommand{\eNappendix}{\setcounter{chapter}{1}%
\renewcommand{\thechapter}{\Alph{chapter}}%
\trackfifty{APPENDIX \thechapter}\addtocounter{chapter}{1}}

\long\def\endnote#1{%%%% For notes at end of chapter
\global\advance\notenum by 1\relax\leavevmode\enotenumstyle%\ [\the\notenum]%
\global\advance\endnotenum by 1\relax%
\long\expandafter\gdef\csname note\the\notenum\endcsname{%
%{\leftskip=1.5pc\footnotesize\hsize=\textwidth\relax%
%\noindent\llap{\hbox to 1.5pc{\the\notenum.\hfill}}%
%#1\strut\vskip1sp}\vskip1pt}%
%%%% now for endnotes:
\enotesize\hsize=\textwidth\relax%
\the\notenum.\ignorespaces\enskip\ignorespaces#1\par}%
\ifnum\notenum=1\relax%
\immediate\write\@auxout{\string\expandafter\string\gdef\string\csname\space
chapendnote\the\endnotenum\string\endcsname{%
%% The commented out part Might be good, but malfunctioned on first small test.
\ifnum\c@chapter>2 \string\newpage\fi
\string\goodbreak\string\vskip13pt\string\penalty-8000%
{\string\enoteheadfont\string\sansheavy\string\bgroup%\space \string\notename\ 
\ifnum\c@chapter>0
\ifappendon \string\eNappendix\else
\string\eNchapter\string\egroup\fi%
\else Frontmatter\fi}\string\vskip3pt\global\notenum=1}}\fi%
\long\expandafter\gdef\csname endnote\the\endnotenum\endcsname{%
%{\leftskip=1.5pc\footnotesize\hsize=\textwidth\relax%
%\noindent\llap{\hbox to 1.5pc{\the\notenum.\hfill}}%
%#1\strut\vskip1sp}
\enotesize\hsize=\textwidth\relax%
\the\notenum.\ignorespaces\enskip\ignorespaces#1\par}%
}%}

\def\chapternotes{\ifnum\notenum>0
\section*{\small\bfseries\itshape Notes for Chapter \arabic{chapter}}%
%\markright{Notes for Chapter \arabic{chapter}}%
\addcontentsline{toc}{section}{\protect\numberline{}Chapter Notes}%
\parindent=0pt%
\parskip=2pt%
\notenum=0%
\noindent\loop\global\advance\notenum by1\relax%
\expandafter\ifx\csname note\the\notenum\endcsname\relax%
\else%
\csname note\the\notenum\endcsname\relax%
\expandafter\gdef\csname note\the\notenum\endcsname{\relax}%
\repeat%
\fi%
\global\notenum=0\relax%
\vskip1sp%
\leftskip=0pt\relax}%

\def\theendnotes{\chapter*{Notes}%
\def\enotenumstyle{\ [\the\notenum]}%
%\vspace{-19\p@}%
\vspace{-16.5\p@}%
\markboth{Notes}{Notes}%
\let\quote\enotequote%
\let\endquote\endenotequote%
\parindent=0pt%
\parskip=2pt%
\endnotenum=0%
\noindent\loop\global\advance\endnotenum by1\relax%
\global\advance\notenum by 1%
\expandafter\ifx\csname endnote\the\endnotenum\endcsname\relax%
\else%
\expandafter\csname chapendnote\the\endnotenum\endcsname%
\expandafter\csname endnote\the\endnotenum\endcsname%
\repeat%
\vskip1sp%
\leftskip=0pt\relax}%

%%%%

\usepackage[notes,backend=biber]{biblatex-chicago}%
\AtEveryBibitem{\global\undef\bbx@lasthash}%
\defbibheading{bibliography}[\bibname]{%
\chapter*{Bibliography}%
\markboth{Bibliography}{Bibliography}\vspace{-2.5\p@}\vspace*{4\p@}}
\setlength{\bibhang}{5\p@}%
\setlength{\bibitemsep}{6\p@}%
%\setlength{\biblabelsep}{-10\p@}%
\def\bibfont{\refsize}%
%\setlength{\bibhang}{1cm}
%%%
\newlength{\bibleftadd}%
\setlength{\bibleftadd}{-5\p@}%
%%
\defbibenvironment{bibliography}
  {\vspace{-2\p@}\markboth{\bibname}{\bibname}\list%
     {}%
     {\setlength{\topsep}{\z@}\setlength{\leftmargin}{\bibhang}%
      \setlength{\itemindent}{-\leftmargin}%
      \addtolength{\leftmargin}{\bibleftadd}%
      \setlength{\itemsep}{\bibitemsep}%
      \setlength{\parsep}{\bibparsep}}}
  {\endlist}
  {\item}
\makeatletter
%%%
%%%

%Math parameters

\setlength{\jot}{4\p@} 

\def\frenchspacing{\sfcode`\.\@m \sfcode`\?\@m \sfcode`\!\@m
  \sfcode`\:\@m \sfcode`\;\@m \sfcode`\,\@m}

\def\@mathmargin{1.5pc}
\vbadness=9999
\tolerance=9999
\doublehyphendemerits=10000
\doublehyphendemerits 640000   % corresponds to badness 800
\finalhyphendemerits  1000000  % corresponds to badness 1000

% Table and array parameters
\setlength\arraycolsep{.5em}
\setlength\tabcolsep{.5em}
\setlength\arrayrulewidth{.25pt}
\setlength\doublerulesep{2.5pt}
\renewcommand\arraystretch{1}

\def\@fmbmdottedtocline#1#2#3#4#5{%
  \renewcommand\@dotsep{1000}
  \ifnum #1>\c@tocdepth \else
    \vskip \z@ %
    {\leftskip #2\relax \rightskip \@tocrmarg %\parfillskip -\rightskip
     \parindent #2\relax\@afterindenttrue
     \interlinepenalty\@M
     \leavevmode
     \@tempdima #3\relax
     \advance\leftskip \@tempdima \null\nobreak\hskip -\leftskip
     {\fontsize{8\p@}{13.5\p@}\sf\selectfont\uppercase{#4}}\nobreak\ignorespaces\quad\ignorespaces%
{\fontsize{7\p@}{13.5\p@}\selectfont\sf#5}%
%     \leaders\hbox{$\m@th \mkern \@dotsep mu\hbox{.}\mkern \@dotsep
%        mu$}\hfill
%     \nobreak
%     \hb@xt@\@pnumwidth{\hfil\normalcolor\fontsize{7\p@}{14\p@}\selectfont\sf#5}%
     \par}%
  \fi}

\def\@dottedtocline#1#2#3#4#5{%
  \renewcommand\@dotsep{1000}%
  \ifnum #1>\c@tocdepth \else%
    \vskip \z@ %
    {\leftskip #2\relax \rightskip \@tocrmarg %\parfillskip -\rightskip%
     \parindent #2\relax\@afterindenttrue%
     \interlinepenalty\@M%
     \leavevmode%
     \@tempdima #3\relax%
     \advance\leftskip \@tempdima \null\nobreak\hskip -\leftskip%
\fontsize{8}{12}\selectfont%
     {\fontsize{8}{12}\selectfont#4}\nobreak\ignorespaces\quad\ignorespaces%
{\fontsize{7}{12}\selectfont#5}%
%     \leaders\hbox{$\m@th \mkern \@dotsep mu\hbox{.}\mkern \@dotsep%
%        mu$}\hfill%
%     \nobreak%
%     \hb@xt@\@pnumwidth{\hfil\normalcolor\fontsize{9}{13}\selectfont#5}%%
     \par}%%
  \fi}%

\def\@subsecdottedtocline#1#2#3#4#5{%
  \renewcommand\@dotsep{1000}%
  \ifnum #1>\c@tocdepth \else%
\def\numberline##1{\hb@xt@\@tempdima{{##1}\hfil}}%
    \vskip \z@ %
    {\leftskip #2\relax \rightskip \@tocrmarg %\parfillskip -\rightskip%
     \parindent #2\relax\@afterindenttrue%
     \interlinepenalty\@M%
     \leavevmode%
     \@tempdima #3\relax%
     \advance\leftskip \@tempdima \null\nobreak\hskip -\leftskip%
\fontsize{8}{12}\selectfont%
     {\fontsize{8}{12}\fontshape{it}\selectfont#4}\nobreak\ignorespaces\quad\ignorespaces%
{\fontsize{7}{12}\selectfont#5}%
%     \leaders\hbox{$\m@th \mkern \@dotsep mu\hbox{.}\mkern \@dotsep%
%        mu$}\hfill%
%     \nobreak%
%     \hb@xt@\@pnumwidth{\hfil\normalcolor\fontsize{9}{13}\selectfont#5}%%
     \par}%%
  \fi}%

\def\@contributordottedtocline#1#2#3#4#5{%
    \renewcommand\@dotsep{1000}
  \ifnum #1>\c@tocdepth \else
    \vskip -6\p@ %
    {\leftskip #2\relax \rightskip \@tocrmarg \parfillskip -\rightskip
     \parindent #2\relax\@afterindenttrue
     \interlinepenalty\@M
     \leavevmode
     \@tempdima #3\relax
     \advance\leftskip \@tempdima \null\nobreak\hskip -\leftskip
\fontsize{8}{12}\selectfont%
     {\fontsize{8}{12}\selectfont\sf#4}\nobreak
     \leaders\hbox{$\m@th \mkern \@dotsep mu\hbox{.}\mkern \@dotsep
        mu$}\hfill
  \nobreak
     \hb@xt@\@pnumwidth{\hfil\normalcolor\normalsize}%
     \par}%
\vspace{6pt}
  \fi}


\def\@chapterdottedtocline#1#2#3#4#5{%
  \begingroup
\def\numberline##1{\hb@xt@\@tempdima{{##1}\hfil}}
  \renewcommand\@dotsep{1000}
  \ifnum #1>\c@tocdepth \else
    \vskip 4pt\goodbreak
    {\leftskip #2\relax   \rightskip \@tocrmarg %\parfillskip -\rightskip
     \parindent #2\relax\@afterindenttrue
     \interlinepenalty\@M
     \leavevmode
     \@tempdima #3\relax
     \advance\leftskip \@tempdima \null\nobreak\hskip -\leftskip
\fontsize{8}{14}\selectfont%
     {\fontsize{8}{14}\selectfont\sansheavy{\uppercase{#4}}}\nobreak\ignorespaces\quad\ignorespaces%
{\fontsize{7}{14}\selectfont\sansheavy{#5}}%
%     \leaders\hbox{$\m@th         \mkern \@dotsep mu\hbox{.}\mkern \@dotsep
%        mu$}\hfill
%      \nobreak
%     \hb@xt@\@pnumwidth{\hfil\normalcolor{\fontsize{9}{13}\selectfont#5}}%
     \par}%
  \endgroup
\vspace{6\p@}  \fi}

\def\@appendixdottedtocline#1#2#3#4#5{%
  \begingroup
  \renewcommand\@dotsep{1000}
  \ifnum #1>\c@tocdepth \else
    \vskip 9pt\goodbreak
    {\leftskip #2\relax   \rightskip \@tocrmarg \parfillskip -\rightskip
     \parindent #2\relax\@afterindenttrue
     \interlinepenalty\@M
     \leavevmode
     \@tempdima #3\relax
     \null\nobreak\hskip -\leftskip
     {\bfseries #4}\nobreak
     \leaders\hbox{$\m@th         \mkern \@dotsep mu\hbox{.}\mkern \@dotsep
        mu$}\hfill
     \nobreak
     \hb@xt@\@pnumwidth{\hfil\normalcolor\normalsize {\bfseries #5}}%
     \par}%
  \endgroup
  \fi}

\def\@partdottedtocline#1#2#3#4#5{%
  \begingroup
  \def\numberline##1{\hbox to 18\p@{{##1\hss}}}
  \renewcommand\@dotsep{1000}
  \ifnum #1>\c@tocdepth \else
    \vskip 10pt\goodbreak
    {\raggedright\leftskip #2\relax   %\rightskip \@tocrmarg %\parfillskip -\rightskip
     \parindent #2\relax\@afterindenttrue
     \interlinepenalty\@M
     \leavevmode
     \@tempdima #3\relax
\advance\leftskip \@tempdima%%added
     \null\nobreak\hskip -\leftskip%\advance\hangindent by 6\p@%
     {\fontsize{8\p@}{14\p@}\selectfont\sansheavy{\uppercase{#4}}}\nobreak%
%     \leaders\hbox{$\m@th         \mkern \@dotsep mu\hbox{.}\mkern \@dotsep
%        mu$}\hfill
%     \nobreak
%     \hb@xt@\@pnumwidth{\hfil
%\ignorespaces\quad\ignorespaces\normalcolor{\fontsize{7\p@}{14\p@}\selectfont\sansheavy{#5}}%
     \par%\vspace{2\p@}
}%
  \endgroup
  \fi}

\def\@figtabdottedtocline#1#2#3#4#5{%
  \renewcommand\@dotsep{1000}%
  \ifnum #1>\c@tocdepth \else\parindent\z@%
\def\numberline##1{{{\sansheavy{##1}}\ignorespaces\enskip\ignorespaces}}
    \vskip \z@ %
    {%\leftskip #2\relax \rightskip \@tocrmarg %\parfillskip -\rightskip%
     %\parindent #2\relax\@afterindenttrue%
     %\interlinepenalty\@M%
     %\leavevmode%
     %\@tempdima #3\relax%
     %\advance\leftskip \@tempdima \null\nobreak\hskip -\leftskip%
\normalsize%
     {#4}\nobreak\ignorespaces\quad\ignorespaces%
{#5}%
%     \leaders\hbox{$\m@th \mkern \@dotsep mu\hbox{.}\mkern \@dotsep%
%        mu$}\hfill%
%     \nobreak%
%     \hb@xt@\@pnumwidth{\hfil\normalcolor\fontsize{9}{13}\selectfont\sf#5}%%
     \par\vspace{2\p@}}%%
  \fi}%

\newcommand\@pnumwidth{1.5pc}
\newcommand\@tocrmarg{2.55em plus 1fil}
\newcommand\@dotsep{1}             %%% <-- very large value so we don't get any dots
\newcommand\tableofcontents{%
    \if@twocolumn
      \@restonecoltrue\onecolumn
    \else
      \@restonecolfalse
    \fi

    \chapter*{Contents}
\markboth{Contents}{Contents}
    \chaptermark{Contents}       %% <-- check the running heads in all \chapter*
    \@starttoc{toc}%                    %%      Code manually with \markboth{}{}
    \if@restonecol\twocolumn\fi
    }

\newcommand\listoffigures{%
    \if@twocolumn
      \@restonecoltrue\onecolumn
    \else
      \@restonecolfalse
    \fi
    \chapter*{List of Figures}%
%\addcontentsline{toc}{fmbm}{\listfigurename}
      \@mkboth{\MakeUppercase\listfigurename}%
              {\MakeUppercase\listfigurename}%
    \@starttoc{lof}%
    \if@restonecol\twocolumn\fi
    }
\newcommand*\l@figure{\@figtabdottedtocline{1}{\z@}{23.5\p@}}%
\newcommand\listoftables{%
    \if@twocolumn
      \@restonecoltrue\onecolumn
    \else
      \@restonecolfalse
    \fi
    \chapter*{List of Tables}%
%\addcontentsline{toc}{fmbm}{\listtablename}
      \@mkboth{%
          \MakeUppercase\listtablename}%
         {\MakeUppercase\listtablename}%
    \@starttoc{lot}%
    \if@restonecol\twocolumn\fi
    }
\let\l@table\l@figure

\setcounter{tocdepth}{1}%

\newcommand*\l@book[1]{{\vspace{\bigskipamount}\vspace{\medskipamount}\noindent{\large\bfseries #1}}}
\newcommand*\l@part{\@partdottedtocline{0}{0em}{18pt}}
\newcommand*\l@fmbm{\@fmbmdottedtocline{0}{18\p@}{0pt}}
\newcommand*\l@chapter{\@chapterdottedtocline{1}{18pt}{17pt}}
\newcommand*\l@section{\@dottedtocline{2}{35pt}{17pt}}
\newcommand*\l@contributor{\@contributordottedtocline{2}{35pt}{24pt}}
\newcommand*\l@subsection{\@subsecdottedtocline{3}{52pt}{24pt}}
\newcommand*\l@subsubsection{\@dottedtocline{4}{76.5pt}{35pt}}
\newcommand*\l@paragraph{\@dottedtocline{5}{114pt}{40pt}}
\newcommand*\l@subparagraph{\@dottedtocline{5}{154.5pt}{50pt}}
\newcommand*\l@appendix{\@appendixdottedtocline{2}{0em}{17pt}}
\newcommand*\l@appsection{\@dottedtocline{2}{17pt}{23pt}}
\newcommand*\l@endmatter{\@chapterdottedtocline{2}{0em}{0em}}


\flushbottom%
\frenchspacing%
\ps@headings%
\onecolumn%
\fnbelowfloat%

\graphicspath{{g:/artwork/oup/Jork/}}

\hyphenation{Figure Figures Table Tables Section Sections}

% Reset eqnarray to avoid to avoid \arraycolsep between 
% columns. Take from a post on comp.text.tex 
% by Fred Bartlett <fbartlet@optonline.net> 
\newif\if@alignpoint
\def\eqnarray{%
  \stepcounter{equation}%
  \def\@currentlabel{\p@equation\theequation}%
  \global\@eqnswtrue
  \m@th
  \global\@eqcnt\z@
  \tabskip\@centering
  \let\\\@eqncr
  $$\everycr{}\halign to\displaywidth\bgroup
    \hskip\@centering$\displaystyle\tabskip\z@skip{##}$\@eqnsel
  &\global\@eqcnt\@ne\hfil\setbox\z@\hbox{$\displaystyle{{}##{}}$}%
    \global\ifdim\wd\z@>\z@\@alignpointtrue\else\@alignpointfalse\fi
    \box\z@\hfil
  &\global\@eqcnt\tw@$\displaystyle{\if@alignpoint\else{}\fi##}$\hfil
    \tabskip\@centering
  &\global\@eqcnt\thr@@ \hb@xt@\z@\bgroup\hss##\egroup
         \tabskip\z@skip
  \cr}


\def\th@definition{%
  \thm@headsep 1em minus\p@\relax
%%  \let\thm@indent\noindent % no indent
\thm@headfont{\bfseries}% heading font is bold
%%  \thm@notefont{}% same as heading font
\thm@headpunct{}% no period after heading
%%  \let\thm@swap\@gobble
\thm@preskip\bigskipamount
%%  \thm@postskip\theorempreskipamount
  \itshape % body font
}

%%%Appendix%%
\newenvironment{chapappendix}[1][\relax]{\bgroup%
\vspace{11pt}%%%
\noindent{\fontsize{10\p@}{13\p@}\selectfont\mathversion{bold}\raggedright\sansheavy{#1}\par}%
\let\section\appsection%
\let\subsection\appsubsection%
\let\subsubsection\appsubsubsection%
\let\paragraph\appparagraph%
\let\subparagraph\appsubparagraph%
\let\quote\appquote%
\let\endquote\endappquote%
\let\extract\appquote%
\let\endextract\endappquote%
\renewcommand{\thechapter}{\Alph{chapter}}%
\setcounter{chapter}{1}%
\setcounter{section}{0}%
\setcounter{subsection}{0}%
\setcounter{subsubsection}{0}%
%\fontsize{8}{10}\selectfont
%\footnotesize%
\fontsize{8}{11.5}\selectfont%
}{\par\egroup}%

\newcommand\appsection{\@startsection {section}{1}{\z@}%
                                     {-11.5\p@}%
                                     {11.5\p@}%
{\fontsize{9\p@}{13\p@}\selectfont\mathversion{bold}\raggedright\sansheavy}}

\newcommand\appsubsection{\@startsection{subsection}{2}{\z@}%
                                     {-11.5\p@}%
                                     {0.01\p@}%
{\fontsize{9\p@}{13\p@}\selectfont\mathversion{bold}\raggedright}}

\newcommand\appsubsubsection{\@startsection{subsubsection}{3}{\z@}%
                                     {-11.5\p@}%
                                     {-9\p@}%
{\fontsize{9\p@}{13\p@}\selectfont\mathversion{bold}\raggedright}}

\newcommand\appparagraph{\@startsection{paragraph}{4}{\z@}%
                                     {-11.5\p@}%
                                     {-9\p@}%
{\fontsize{9\p@}{13\p@}\selectfont\raggedright}}

\newcommand\appsubparagraph{\@startsection{subparagraph}{5}{\z@}%
                                     {-11.5\p@}%
                                     {-9\p@}%
{\fontsize{9\p@}{13\p@}\selectfont\raggedright}}

%%%Appendix%%
\newcounter{appcounter}%
\setcounter{appcounter}{0}
%\refstepcounter{appcounter}%
\renewcommand{\theappcounter}{\Alph{appcounter}}%

\def\appendix{\par%
\global\appendontrue%
\let\@makechapterhead\@makeappchapterhead%
\renewcommand{\chaptername}{Appendix}%
  \renewcommand{\thechapter}{\Alph{chapter}}%
        \setcounter{chapter}{0}%
        \setcounter{section}{0}%
        \setcounter{table}{0}%
        \setcounter{figure}{0}%
        \setcounter{equation}{0}%
        \setcounter{subsection}{0}%
\let\section\appsection%
\let\subsection\appsubsection%
\let\subsubsection\appsubsubsection%
\let\paragraph\appparagraph%
\let\subparagraph\appsubparagraph%
%        \appendtrue
\def\chaptername{Appendix}%
%\footnotesize%
\fontsize{8}{11.5}\selectfont%
}


\newtheoremstyle{common}
    {9pt}% above space (default)
    {9pt}% below space
    {\small\itshape}% body
    {0em}% indent
    {\bf}% head
    {}% punct
    {9\p@}% space
%    {}% custom
{\thmname{\sansbold{#1}}\thmnumber{\@ifnotempty{\sansbold{#1}}{ }{\sansbold{#2}}}%
 \thmnote{ {\sansbold{(#3)}}}}% theorem head
\theoremstyle{common}

\newtheoremstyle{boxcommon}
    {8pt}% above space (default)
    {8pt}% below space
    {\footnotesize\itshape}% body
    {0em}% indent
    {\bf}% head
    {}% punct
    {9\p@}% space
%    {}% custom
{\thmname{\sansbold{#1}}\thmnumber{\@ifnotempty{\sansbold{#1}}{ }{\sansbold{#2}}}%
 \thmnote{ {\sansbold{(#3)}}}}% theorem head


%%%With Chapter Number
\ifthmcountchapter
\newtheorem{theorem}{Theorem}[chapter]%
\newtheorem{corollary}{Corollary}[chapter]%
\newtheorem{example}{Example}[chapter]%
\newtheorem{lemma}{Lemma}[chapter]%
\newtheorem{definition}{Definition}[chapter]%
\newtheorem{proposition}{Proposition}[chapter]%
\newtheorem{assumption}{Assumption}[chapter]%
\newtheorem{remark}{Remark}[chapter]%
\else
\ifthmcountcont
\newtheorem{theorem}{Theorem}%
\newtheorem{corollary}[theorem]{Corollary}%
\newtheorem{example}[theorem]{Example}%
\newtheorem{lemma}[theorem]{Lemma}%
\newtheorem{definition}[theorem]{Definition}%
\newtheorem{proposition}[theorem]{Proposition}%
\newtheorem{assumption}[theorem]{Assumption}%
\newtheorem{remark}[theorem]{Remark}%
\else
\newtheorem{theorem}{Theorem}%
\newtheorem{corollary}{Corollary}%
\newtheorem{example}{Example}%
\newtheorem{lemma}{Lemma}%
\newtheorem{definition}{Definition}%
\newtheorem{proposition}{Proposition}%
\newtheorem{assumption}{Assumption}%
\newtheorem{remark}{Remark}%
\fi\fi

%%%Proof%%
\renewenvironment{proof}[1][\proofname]{\par%
  \pushQED{\qed}%
  \normalfont \topsep6\p@\relax%
  \trivlist%
\itemindent\z@  \item[\hskip\labelsep%
        \itshape%
    #1\@addpunct{.}\hspace{2.5\p@}]\ignorespaces%
}{%
  \popQED\endtrivlist\@endpefalse%
}%

\let\cal\mathcal

\makeindex

% Author queries
\newcommand{\query}[2][0pt]{%
  \marginpar{\vspace*{#1}%
    \fbox{\parbox{6pc}{%
     \raggedright\small
        AQ: #2}}}}

%%only for MIT
\font\ldotsfnt=psyr scaled 1000%Donot change this, fixed as per client requirement
\def\ldots{\nobreak\,\nobreak\hbox{\ldotsfnt\char188}\,\allowbreak}%

\AtBeginDocument{%
\thinmuskip=3mu%
\medmuskip=3mu%
\thickmuskip=3mu%
}%

\RequirePackage[bookmarks=true,bookmarksnumbered=true,bookmarksopenlevel=1,colorlinks=false,breaklinks,linkcolor=black,citecolor=black,urlcolor=black,hidelinks]{hyperref}%
\ifxetex\relax\else\usepackage{breakurl}\fi%
%\ifluatex\relax\else\usepackage{breakurl}\fi%
\urlstyle{rm}%
\def\url@acsstyle{%
  \def\UrlSpecials{%
    \do\/{\penalty\UrlBreakPenalty\mathchar`/}%
    \do\~{\penalty\UrlBreakPenalty\mathchar`~}%
    \do\.{\penalty\UrlBreakPenalty\mathchar`.}%
    \do\,{\penalty\UrlBreakPenalty\mathchar`,}%
    \do\-{\penalty\UrlBreakPenalty\mathchar`-}%
    \do\_{\penalty\UrlBreakPenalty\mathchar`_}%
    \do\?{\penalty\UrlBreakPenalty\mathchar`?}%
    \do\#{\penalty\UrlBreakPenalty\mathchar"23}%
    \do\%{\Url@percent}%
    \do\={\penalty\UrlBreakPenalty\mathchar`=\penalty\UrlBreakPenalty}%
    \do\&{\penalty\UrlBreakPenalty\mathchar`&\penalty\UrlBreakPenalty}%
    \do\ {\Url@space}\do\^^M{\Url@space}%
    \Url@force@Tilde}%
}
\urlstyle{acs}%

\def\blankline{\vskip13pt\noindent\ignorespaces}

\newcounter{exercise}
\newcounter{subexercise}
\newcounter{subsubexercise}

\def\exercises{\section*{Exercises}\vspace{-12pt}\footnotesize%
\addcontentsline{toc}{section}{\protect\numberline{}Exercises}%
\setcounter{exercise}{0}%
\parindent=2pc%
\parskip=4pt%
}

\def\endexercises{}

\long\def\exer#1{\vskip3pt\global\advance\c@exercise by 1
\global\c@subexercise=0
{\leftskip=1pc
\noindent\hskip-1pc\hbox to 1pc{\bf \arabic{exercise}.\hfill}\ignorespaces#1
\vskip1sp}
}

\long\def\subexer#1{\vskip3pt\global\advance\c@subexercise by 1
\global\c@subsubexercise=0
{\leftskip=2pc
\noindent\hskip-1pc\hbox to
1pc{\bf\alph{subexercise})\hfill}\ignorespaces#1\vskip1sp}} 

\long\def\subsubexer#1{\vskip3pt\global\advance\c@subsubexercise by 1
{\leftskip=3pc
\noindent\hskip-1pc\hbox to 1pc{\bf\roman{subsubexercise}.\hfill}\ignorespaces#1\vskip1sp}}

\def\sidebysidesubexer#1#2{\vskip3pt\centerline{\hskip1pc\vtop{\global\advance\c@subexercise by 1
\advance\hsize -1pc \hsize=.5\hsize
\noindent\hbox to 1pc{\bf\alph{subexercise})\hfill}
#1}\hfill\vtop{\global\advance\c@subexercise by 1 
\advance\hsize -1pc \hsize=.5\hsize
\noindent\hbox to 1pc{\bf\alph{subexercise})\hfill} #2}}}

\def\sidebysidesubsubexer#1#2{\vskip3pt\centerline{\hskip2pc\vtop{\global\advance\c@subsubexercise
by 1\relax%
\advance\hsize -2pc \hsize=.5\hsize
\noindent\hbox to 1pc{\bf\roman{subsubexercise}.\hfill}#1}\hfill\vtop{\global\advance\c@subsubexercise by 1
\advance\hsize -2pc \hsize=.5\hsize
 \noindent\hbox to 1pc{\bf\roman{subsubexercise}.\hfill}#2}}}

\def\endbookexercises{\chapter*{Exercises}\footnotesize
\vspace{-5\p@}%
%\def\tabular{\blankline\footnotesize\savetabular}
%\@namedef{tabular*}##1{\blankline\def\@halignto{to##1}
%\footnotesize\@tabular}
%\markright{Exercises}
\setcounter{exercise}{0}
\parindent=2pc
\parskip=4pt
}

\def\endendbookexercises{}

%%%%


\usepackage{algorithm} %% 
\usepackage{algorithmicx}
\usepackage{algpseudocode}

%% Glossary
\def\glossary{\chapter*{Glossary}\addcontentsline{toc}{fmbm}{Glossary}\bgroup\footnotesize%
\vspace{2\p@}%
\parindent=0pt
}
\def\endglossary{\vskip1sp\egroup}

%\long\def\term#1#2{\noindent\hbox to
%.8in{\vtop{\raggedright\hsize=.7in\footnotesize%
%\sansbold{#1}}}\vtop{\footnotesize\advance\hsize-.8in
%#2}\vskip10pt}

\newcommand{\term}[2]{\bgroup%
\footnotesize%
\noindent\sansheavy{#1}\ignorespaces\hspace{7.5\p@}\ignorespaces%
{#2\par}\vspace{6\p@}\egroup}%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Notation
\def\notation{\vskip7pt\bgroup\parskip=0pt
\noindent{\fontsize{9}{13}\selectfont\sansbold{Notation}}
\vskip1pt
\let\\=\cr
\halign\bgroup##\hfill\hskip10pt\vrule depth 6pt width0pt height 10pt&##\hfill\\
}
\def\endnotation{\crcr\egroup\egroup\vskip8pt
\global\everypar={\noindent\hskip-\parindent\global\everypar={}}}

\def\dialogue{\bgroup\par\vskip4pt\fontsize{8}{12}\selectfont}%
\def\enddialogue{\par\egroup\vskip4pt}
\def\speaker#1{\vskip-\parskip\vskip2pt\noindent{\sansbold{#1}}\hskip4pt\relax}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\AtBeginDocument{%
\DeclareSymbolFont{numbers}{\encodingdefault}{\rmdefault}{m}{n}%
\DeclareSymbolFont{alphabets}{\encodingdefault}{\rmdefault}{m}{it}%
%
\SetSymbolFont{alphabets}{bold}{\encodingdefault}{\rmdefault}{b}{it}%
\SetSymbolFont{numbers}{bold}{\encodingdefault}{\rmdefault}{b}{n}%
%
\DeclareMathSymbol{0}{\mathalpha}{numbers}{"30}
\DeclareMathSymbol{1}{\mathalpha}{numbers}{"31}
\DeclareMathSymbol{2}{\mathalpha}{numbers}{"32}
\DeclareMathSymbol{3}{\mathalpha}{numbers}{"33}
\DeclareMathSymbol{4}{\mathalpha}{numbers}{"34}
\DeclareMathSymbol{5}{\mathalpha}{numbers}{"35}
\DeclareMathSymbol{6}{\mathalpha}{numbers}{"36}
\DeclareMathSymbol{7}{\mathalpha}{numbers}{"37}
\DeclareMathSymbol{8}{\mathalpha}{numbers}{"38}
\DeclareMathSymbol{9}{\mathalpha}{numbers}{"39}
%%%
\DeclareMathSymbol{A}{\mathalpha}{alphabets}{"41}
\DeclareMathSymbol{B}{\mathalpha}{alphabets}{"42}
\DeclareMathSymbol{C}{\mathalpha}{alphabets}{"43}
\DeclareMathSymbol{D}{\mathalpha}{alphabets}{"44}
\DeclareMathSymbol{E}{\mathalpha}{alphabets}{"45}
\DeclareMathSymbol{F}{\mathalpha}{alphabets}{"46}
\DeclareMathSymbol{G}{\mathalpha}{alphabets}{"47}
\DeclareMathSymbol{H}{\mathalpha}{alphabets}{"48}
\DeclareMathSymbol{I}{\mathalpha}{alphabets}{"49}
\DeclareMathSymbol{J}{\mathalpha}{alphabets}{"4A}
\DeclareMathSymbol{K}{\mathalpha}{alphabets}{"4B}
\DeclareMathSymbol{L}{\mathalpha}{alphabets}{"4C}
\DeclareMathSymbol{M}{\mathalpha}{alphabets}{"4D}
\DeclareMathSymbol{N}{\mathalpha}{alphabets}{"4E}
\DeclareMathSymbol{O}{\mathalpha}{alphabets}{"4F}
\DeclareMathSymbol{P}{\mathalpha}{alphabets}{"50}
\DeclareMathSymbol{Q}{\mathalpha}{alphabets}{"51}
\DeclareMathSymbol{R}{\mathalpha}{alphabets}{"52}
\DeclareMathSymbol{S}{\mathalpha}{alphabets}{"53}
\DeclareMathSymbol{T}{\mathalpha}{alphabets}{"54}
\DeclareMathSymbol{U}{\mathalpha}{alphabets}{"55}
\DeclareMathSymbol{V}{\mathalpha}{alphabets}{"56}
\DeclareMathSymbol{W}{\mathalpha}{alphabets}{"57}
\DeclareMathSymbol{X}{\mathalpha}{alphabets}{"58}
\DeclareMathSymbol{Y}{\mathalpha}{alphabets}{"59}
\DeclareMathSymbol{Z}{\mathalpha}{alphabets}{"5A}
%%%
\DeclareMathSymbol{a}{\mathalpha}{alphabets}{"61}
\DeclareMathSymbol{b}{\mathalpha}{alphabets}{"62}
\DeclareMathSymbol{c}{\mathalpha}{alphabets}{"63}
\DeclareMathSymbol{d}{\mathalpha}{alphabets}{"64}
\DeclareMathSymbol{e}{\mathalpha}{alphabets}{"65}
\DeclareMathSymbol{f}{\mathalpha}{alphabets}{"66}
\DeclareMathSymbol{g}{\mathalpha}{alphabets}{"67}
\DeclareMathSymbol{h}{\mathalpha}{alphabets}{"68}
\DeclareMathSymbol{i}{\mathalpha}{alphabets}{"69}
\DeclareMathSymbol{j}{\mathalpha}{alphabets}{"6A}
\DeclareMathSymbol{k}{\mathalpha}{alphabets}{"6B}
\DeclareMathSymbol{l}{\mathalpha}{alphabets}{"6C}
\DeclareMathSymbol{m}{\mathalpha}{alphabets}{"6D}
\DeclareMathSymbol{n}{\mathalpha}{alphabets}{"6E}
\DeclareMathSymbol{o}{\mathalpha}{alphabets}{"6F}
\DeclareMathSymbol{p}{\mathalpha}{alphabets}{"70}
\DeclareMathSymbol{q}{\mathalpha}{alphabets}{"71}
\DeclareMathSymbol{r}{\mathalpha}{alphabets}{"72}
\DeclareMathSymbol{s}{\mathalpha}{alphabets}{"73}
\DeclareMathSymbol{t}{\mathalpha}{alphabets}{"74}
\DeclareMathSymbol{u}{\mathalpha}{alphabets}{"75}
\DeclareMathSymbol{v}{\mathalpha}{alphabets}{"76}
\DeclareMathSymbol{w}{\mathalpha}{alphabets}{"77}
\DeclareMathSymbol{x}{\mathalpha}{alphabets}{"78}
\DeclareMathSymbol{y}{\mathalpha}{alphabets}{"79}
\DeclareMathSymbol{z}{\mathalpha}{alphabets}{"7A}
}

\endinput